// CWWatcher.h

#ifndef CWWatcher_h
#define CWWatcher_h

#ifndef QDPatchBlock_h
#include "QDPatchBlock.h"
#endif
#ifndef Str_h
#include "Str.h"
#endif
#ifndef Announcer_h
#include "Announcer.h"
#endif

class WindowObject;
class CompileStatistics;

class CWWatcher: private QDPatchBlock,
					  public Announcer
  {
	private:
		String255 file;
		int32 fileLine;
		uint32 filesLeft;
		uint32 oldLines;
		uint32 totalLines;
		uint32 numberToIgnore;
		
		static ConstData Partition();
		static const WindowObject *ToolBar();

		virtual void DrawText( ConstData text,
									  Point numerator,
									  Point denominator );
	
		void Count();
		
		void SeeUncompiledFile( ConstPString name );
		
		static CompileStatistics stats;
		
	public:
		CWWatcher();
		~CWWatcher();
		
		uint32 FilesLeft() const	{ return filesLeft; }
		uint32 TotalLines() const	{ return totalLines; }
		
		ConstPString File() const		{ return file; }
		uint32 FileLine() const			{ return fileLine; }
		uint32 CompiledLines() const	{ return fileLine + oldLines; }
  };

#endif
