// WindowLocator.h

#ifndef WindowLocator_h
#define WindowLocator_h

#ifndef RedBlackLink_h
#include "RedBlackLink.h"
#endif

class AbstractWindow;

class WindowLocator
  {
	public:
		typedef RedBlackLinkTree< WindowPtr, AbstractWindow > TreeType;

	private:
		static TreeType& Tree();

	public:
		typedef RedBlackLink< WindowPtr, AbstractWindow > Registration;
		
		static void Register( Registration& );
		
		virtual AbstractWindow& LocateWindow( WindowPtr );
  };

#endif
