// DiskInsertionReceiver.cp

#ifndef DiskInsertionReceiver_h
#include "DiskInsertionReceiver.h"
#endif
#ifndef BroadcastLoop_h
#include "BroadcastLoop.h"
#endif

DiskInsertionReceiver::DiskInsertionReceiver( bool startEnabled )
  : Receiver< DiskInsertion >( Sender(), startEnabled )
  {
  }

Broadcaster<DiskInsertion>& DiskInsertionReceiver::Sender()
  {
	static Broadcaster<DiskInsertion> sender;
	return sender;
  }

void DiskInsertionReceiver::Send( const DiskInsertionEvent& event,
											 OSErr initializationError )
  {
	for ( BroadcastLoop<DiskInsertion> receiver( Sender() );
			receiver.Unfinished();
			receiver++ )
		if ( initializationError == noErr )
			receiver->ReceiveDiskInsertion( event );
		 else
			receiver->ReceiveDiskInsertionFailure( event, initializationError );
  }

#include "BroadcastLoop.cp"
