// Receiver.h

#ifndef Receiver_h
#define Receiver_h

#ifndef BroadcastLink_h
#include "BroadcastLink.h"
#endif

template < class Protocol >
class Receiver: public Protocol
  {
	typedef Broadcaster< Protocol > Source;
	
	private:
		BroadcastLink< Protocol > link;
	
	public:
		Receiver( const Source& source, bool startEnabled = true )
		  : link( source, *this, startEnabled )
		  {}
		
		Enableable& Link()					{ return link; }
		const Enableable& Link() const	{ return link; }
  };

#endif
