// Assert.h

#ifndef Assert_h
#define Assert_h

#ifndef DebugMessage_h
#include "DebugMessage.h"
#endif

#include "ConfigureAssertions.h"

extern DebugMessage AssertionMessage( const int8 *file,
												  uint32 line,
												  const int8 *condition );

#define Assert( condition )	\
  { \
	if ( useAssertions && !(condition) ) \
		AssertionMessage( __FILE__, __LINE__, #condition ).Show(); \
  }

#endif