// PatternMode.h

#ifndef PatternMode_h
#define PatternMode_h

#ifndef Integers_h
#include "Integers.h"
#endif

class PatternMode
  {
	public:
		enum Mode
		  {
			copy		= ::patCopy,
			or			= ::patOr,
			xor		= ::patXor,
			bic		= ::patBic,
			notCopy	= ::notPatCopy,
			notOr		= ::notPatOr,
			notXor	= ::notPatXor,
			notBic	= ::notPatBic,
			
			blend				= ::blend,
			addPin			= ::addPin,
			addOver			= ::addOver,
			subPin			= ::subPin,
			transparent		= ::transparent,
			addMax			= ::addMax,
			subOver			= ::subOver,
			addMin			= ::adMin	/* sic */
		  };
	
	private:
		Mode mode;
	
	public:
		PatternMode( Mode m )		: mode( m )		{}
		
		static PatternMode Make( int16 value )
			{ return static_cast<Mode>( value ); }
	
		int16 Value() const			{ return mode; }
  };

#endif
