// MouseDownEvent.cp

#ifndef MouseDownEvent_h
#include "MouseDownEvent.h"
#endif
#ifndef Application_h
#include "Application.h"
#endif
#ifndef ScreenPart_h
#include "ScreenPart.h"
#endif
#ifndef UserCancelledError_h
#include "UserCancelledError.h"
#endif
#ifndef UserState_h
#include "UserState.h"
#endif

MouseDownEvent::MouseDownEvent( const EventRecord& event )
  : MouseEvent( event ),
	 screenPart( Application::The().MakeScreenPart( event.where ) ),
	 activating( (event.modifiers & activeFlag) != 0 || !screenPart.Active() )
  {
	Assert( event.what == mouseDown );
  }

void MouseDownEvent::Respond() const
  {
	try
	  {
		screenPart.Click( *this );
	  }
	 catch ( UserCancelledError )
	  {
	  }
	
	UserState::The().Announce();
  }
