// FileReader.h

#ifndef FileReader_h
#define FileReader_h

#ifndef Integers_h
#include "Integers.h"
#endif

class FileAccessPath;
class Buffer;

class FileReader: private ParamBlockRec
  {
	private:
		bool finished;
		
		void ThrowError( OSErr );
		
	public:
		FileReader( const FileAccessPath&, uint32 position = 0 );
		
		uint32 Position() const				{ return ioParam.ioPosOffset; }
		void SetPosition( uint32 p )		{ ioParam.ioPosOffset = p; finished = false; }
		
		bool Finished() const				{ return finished; }
		bool Unfinished() const				{ return !finished; }
		
		uint32 operator>>( Buffer& );
  };

#endif
