// Face.h

#ifndef Face_h
#define Face_h

#ifndef FontNumber_h
#include "FontNumber.h"
#endif
#ifndef FontSize_h
#include "FontSize.h"
#endif

class Face
  {
	private:
		FontNumber font;
		FontSize size;
		::Style style;
	
	public:
		Face( FontNumber theFont, FontSize theSize, ::Style theStyle )
		  : font( theFont ),
			 size( theSize ),
			 style( theStyle )
		  {}
		
		FontNumber Font() const							{ return font; }
		void SetFont( FontNumber f )					{ font = f; }
		
		FontSize Size() const							{ return size; }
		void SetSize( FontSize s )						{ size = s; }

		::Style Style() const							{ return style; }
		void SetStyle( ::Style s )						{ style = s; }
		
		bool operator==( const Face& ) const;
		bool operator!=( const Face& f ) const		{ return !(*this == f); }
		
		static const Face& System();
		static const Face& Application();
		static const Face& Small();
		static const Face& Help();

		static Face System( ScriptCode );
		static Face Application( ScriptCode );
		static Face Small( ScriptCode );
		static Face Help( ScriptCode );
  };

#endif
