// New.cp

#ifndef New_h
#include "New.h"
#endif
#ifndef MemoryFullError_h
#include "MemoryFullError.h"
#endif
#ifndef __ERRORS__
#include <Errors.h>
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

void *operator new( uint32 size )
  {
	void *result = NewPtr( size );
	OSErr error( MemError() );
	
	if ( error == memFullErr )
		throw MemoryFullError();
	
	if ( error != noErr )
		throw MemoryError( error );
	
	if ( result == 0 )
		throw MemoryFullError();
		
	return result;
  }

void operator delete( void *p )
  {
	Assert( p != 0 );
	
	if ( p == 0 )
		return;
	
	DisposePtr( static_cast<Ptr>( p ) );
	
	MemoryError::Check().Throw();
  }
