// Process.cp

#ifndef Process_h
#include "Process.h"
#endif
#ifndef ProcessError_h
#include "ProcessError.h"
#endif

Process::Process( ApplicationProcess )
  {
	ProcessError error( GetCurrentProcess( &psn ) );
	error.Throw();
  }

Process::Process( FrontProcess )
  {
	ProcessError error( GetFrontProcess( &psn ) );
	error.Throw();
  }

const Process& Process::Application()
  {
	static Process theApplication( application );
	return theApplication;
  }

bool Process::operator==( const Process& r ) const
  {
	Boolean result;
	ProcessError error( SameProcess( &psn, &r.psn, &result ) );
	error.Throw();
	
	return !!result;
  }

void Process::Wake() const
  {
	ProcessError error( WakeUpProcess( &psn ) );
	error.Throw();
  }

void Process::MoveToFront() const
  {
	ProcessError error( SetFrontProcess( &psn ) );
	error.Throw();
  }
