// Arrangement.h

#ifndef Arrangement_h
#define Arrangement_h

#ifndef ArrangementBase_h
#include "ArrangementBase.h"
#endif
#ifndef ArrangedPane_h
#include "ArrangedPane.h"
#endif

template < uint32 paneCount >
class Arrangement: public ArrangementBase
  {
	private:
		ArrangedPane panes[ paneCount ];
		
	public:
		Arrangement()
		  : ArrangementBase( panes, paneCount )
		  {
			SetParents();
		  }
		
		ArrangedPane& operator[]( uint32 i )			{ Assert( i < paneCount ); return panes[ i ]; }
		const Pane& operator[]( uint32 i ) const		{ Assert( i < paneCount ); return panes[ i ]; }
  };

#endif
