// ConstArrangementLoop.h

#ifndef ConstArrangementLoop_h
#define ConstArrangementLoop_h

#ifndef ArrangementBase_h
#include "ArrangementBase.h"
#endif

class ConstArrangementLoop
  {
	private:
		const ArrangementBase& arrangement;
		uint32 index;
	
	public:
		ConstArrangementLoop( const ArrangementBase& );
		
		bool Finished() const		{ return index >= arrangement.PaneCount(); }
		bool Unfinished() const		{ return index < arrangement.PaneCount(); }
		
		void operator++();
		void operator++(int)			{ operator++(); }
		
		const Pane& operator*() const		{ return arrangement[index]; }
		const Pane *operator->() const	{ return &arrangement[index]; }
  };

#endif
