// Sizeable.h

#ifndef Sizeable_h
#define Sizeable_h

#ifndef PointObject_h
#include "PointObject.h"
#endif

class Sizeable
  {
	public:
		virtual uint16 MinimumWidth() const;
		virtual uint16 MinimumHeight() const;
		virtual PointObject MinimumSize() const;
		
		virtual uint16 MaximumWidth() const;
		virtual uint16 MaximumHeight() const;
		virtual PointObject MaximumSize() const;
		
		virtual uint16 ReasonableWidth() const;
		virtual uint16 ReasonableHeight() const;
		virtual PointObject ReasonableSize() const;
		
		virtual uint16 BestWidth() const;
		virtual uint16 BestHeight() const;
		virtual PointObject BestSize() const;
		
		virtual uint16 BestWidth( uint16 bound ) const;
		virtual uint16 BestHeight( uint16 bound ) const;
		virtual PointObject BestSize( PointObject bound ) const;
		
		static const Sizeable empty;
  };

#endif
