// SolidFrame.h

#ifndef SolidFrame_h
#define SolidFrame_h

#ifndef Frame_h
#include "Frame.h"
#endif
#ifndef HasForegroundColor_h
#include "HasForegroundColor.h"
#endif

class SolidFrame: public Frame,
						public HasForegroundColor
  {
	private:
		virtual void ForegroundColorChanged();
		
	public:
		SolidFrame( uint16 thickness,
						RGBColor theColor = NamedColors::black )
		  : Frame( Rectangle( -thickness, -thickness, thickness, thickness ) ),
			 HasForegroundColor( theColor )
		  {}

		SolidFrame( PointObject thickness,
						RGBColor theColor = NamedColors::black )
		  : Frame( Rectangle( -thickness.h, -thickness.v, thickness.h, thickness.v ) ),
			 HasForegroundColor( theColor )
		  {}

		SolidFrame( Rectangle thickness,
						RGBColor theColor = NamedColors::black )
		  : Frame( thickness ),
			 HasForegroundColor( theColor )
		  {}
		
		virtual void DrawBorder( const ViewMap&, Rectangle interior ) const;
  };

#endif
