// GrowBelowArrangement.h

#ifndef GrowBelowArrangement_h
#define GrowBelowArrangement_h

#ifndef Arrangement_h
#include "Arrangement.h"
#endif
#ifndef SolidView_h
#include "SolidView.h"
#endif
#ifndef GrowBox_h
#include "GrowBox.h"
#endif

class GrowBelowArrangement: public Arrangement<4>
  {
	private:
		SolidView bottomLine;
		GrowBox grow;
		
		enum { barSize = 15 };
		
	protected:
		virtual void Arrange( Rectangle );
	
	public:
		GrowBelowArrangement( WindowFocus& );
		
		const Pane& Grow() const					{ return (*this)[0]; }
		const Pane& BottomLine() const			{ return (*this)[1]; }
		const Pane& Bottom() const					{ return (*this)[2]; }
		const Pane& Main() const					{ return (*this)[3]; }
		
		ArrangedPane& Grow()							{ return (*this)[0]; }
		ArrangedPane& BottomLine()					{ return (*this)[1]; }
		ArrangedPane& Bottom()						{ return (*this)[2]; }
		ArrangedPane& Main()							{ return (*this)[3]; }
		
		virtual uint16 MinimumWidth() const;
		virtual uint16 MinimumHeight() const;
		
		virtual uint16 MaximumWidth() const;
		virtual uint16 MaximumHeight() const;

		virtual uint16 ReasonableWidth() const;
		virtual uint16 ReasonableHeight() const;
		
		virtual uint16 BestWidth() const;
		virtual uint16 BestWidth( uint16 bound ) const;
		
		virtual uint16 BestHeight() const;
		virtual uint16 BestHeight( uint16 bound ) const;
  };

#endif
