// PaneColumn.h

#ifndef PaneColumn_h
#define PaneColumn_h

#ifndef PaneColumnBase_h
#include "PaneColumnBase.h"
#endif

template < uint32 paneCount >
class PaneColumn: public PaneColumnBase
  {
	private:
		ArrangedPane panes[ paneCount ];
	
	public:
		PaneColumn()
		  : PaneColumnBase( panes, paneCount )
		  {
			SetParents();
		  }
		
		ArrangedPane& operator[]( uint32 i )
			{ Assert( i < paneCount ); return panes[ i ]; }
		
		const Pane& operator[]( uint32 i ) const
			{ Assert( i < paneCount ); return panes[ i ]; }
  };

#endif
