// PaneRow.h

#ifndef PaneRow_h
#define PaneRow_h

#ifndef PaneRowBase_h
#include "PaneRowBase.h"
#endif

template < uint32 paneCount >
class PaneRow: public PaneRowBase
  {
	private:
		ArrangedPane panes[ paneCount ];
	
	public:
		PaneRow()
		  : PaneRowBase( panes, paneCount )
		  {
			SetParents();
		  }
		
		ArrangedPane& operator[]( uint32 i )
			{ Assert( i < paneCount ); return panes[ i ]; }
		
		const Pane& operator[]( uint32 i ) const
			{ Assert( i < paneCount ); return panes[ i ]; }
  };

#endif
