// GrayWhiteView.cp

#ifndef GrayWhiteView_h
#include "GrayWhiteView.h"
#endif
#ifndef ViewMap_h
#include "ViewMap.h"
#endif
#ifndef WindowFocus_h
#include "WindowFocus.h"
#endif
#ifndef BackgroundColorMaintainer_h
#include "BackgroundColorMaintainer.h"
#endif
#ifndef NamedColors_h
#include "NamedColors.h"
#endif

GrayWhiteView::GrayWhiteView( WindowFocus& focus )
  : Activator( focus )
  {
  }

void GrayWhiteView::Activate()
  {
	Redraw();
  }

void GrayWhiteView::Deactivate()
  {
	Redraw();
  }

void GrayWhiteView::Draw( const ViewMap& map ) const
  {
	BackgroundColorMaintainer cm( Active()
												? NamedColors::appleGray1
												: NamedColors::white );
	map.Erase();
  }
