// GrowBox.cp

#ifndef GrowBox_h
#include "GrowBox.h"
#endif
#ifndef ViewMap_h
#include "ViewMap.h"
#endif
#ifndef WindowFocus_h
#include "WindowFocus.h"
#endif
#ifndef GrafPortObject_h
#include "GrafPortObject.h"
#endif

GrowBox::GrowBox( WindowFocus& focus )
  : Activator( focus )
  {
  }

void GrowBox::Activate()
  {
	Redraw();
  }

void GrowBox::Deactivate()
  {
	Redraw();
  }
 
void GrowBox::Draw( const ViewMap& map ) const
  {
	Assert( map.Bounds().BottomRight() == map.Port().LocalBounds().BottomRight() );
	Assert( map.Bounds().Width() == 15 );
	Assert( map.Bounds().Height() == 15 );
	DrawGrowIcon( &map.Port() );
  }

uint16 GrowBox::MinimumWidth() const
  {
	return 15;
  }

uint16 GrowBox::MinimumHeight() const
  {
	return 15;
  }

uint16 GrowBox::MaximumWidth() const
  {
	return 15;
  }

uint16 GrowBox::MaximumHeight() const
  {
	return 15;
  }
