// ProgressView.h

#ifndef ProgressView_h
#define ProgressView_h

#ifndef View_h
#include "View.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif

class Progress;

class ProgressView: public View
  {
	private:
		const Progress& progress;
		Ear<ProgressView> ear;
		int16 split;
		
		void UpdateSplit();
		
		virtual void GainMapping();
		virtual void ChangeBounds( Rectangle oldBounds );
		
	public:
		ProgressView( const Progress& );
		~ProgressView();
		
		virtual void Draw( const ViewMap& ) const;

		virtual uint16 MinimumWidth() const;
		virtual uint16 MinimumHeight() const;
		
		virtual uint16 ReasonableWidth() const;
		virtual uint16 ReasonableHeight() const;
		
		virtual uint16 BestWidth() const;
		virtual uint16 BestHeight() const;
  };

#endif
